/**
  *  \file client/dlg-subject.h
  *  \brief Message Subject Overview
  */
#ifndef PCC_V2_CLIENT_DLG_SUBJECT_H
#define PCC_V2_CLIENT_DLG_SUBJECT_H

#include <vector>
#include "ui/listbox.h"
#include "game/msg.h"

class WSubjectList : public UIListbox {
    GMessagebox& mbox;
    GMessageFilter& filter;

    struct Group {
        int first_msg;
        int count;

        Group(int first_msg, int count)
            : first_msg(first_msg), count(count)
            { }
    };
    std::vector<Group> groups;

    void createGroupList();

 public:
    WSubjectList(int id, GMessagebox& mbox, GMessageFilter& filter);
    ~WSubjectList();

    void drawPart(GfxCanvas& can, int from, int to);
    int doStandardDialog();

    int getSelectedMessage() const;
    void selectMessage(int n);
};

#endif
