/**
  *  \file game/sim-game.h
  *  \brief Simulator / Game Interface
  */
#ifndef PCC_V2_GAME_SIM_GAME_H
#define PCC_V2_GAME_SIM_GAME_H

#include "game/sim.h"
#include "game/univ.h"
#include "game/sim-if.h"

class GSimulatorRealGameInterface : public GSimulatorGameInterface {
    GUniverse& univ;
 public:
    GSimulatorRealGameInterface(GUniverse& univ);
    ~GSimulatorRealGameInterface();

    virtual string_t getPlanetName(int id);
    virtual int getShipOwner(int id);
    virtual bool isGameAvailable();
    virtual bool updateFromGame(GSimShip& sh);
    virtual bool updateToGame(const GSimShip& sh);
    virtual bool isGamePlanet(const GSimPlanet& pl);
    virtual bool updateFromGame(GSimPlanet& pl);
    virtual bool updateToGame(const GSimPlanet& pl);

    virtual ShipRelation getShipRelation(const GSimShip& sh);
    virtual bool selectGameShip(const GSimShip& sh);
};

#endif
